searchData={"content_type":"text/markdown","items":[{"doc":"A function to call when decrypting any value. Takes the resource, field, records, and calculation context. Must return `:ok` or `{:error, error}`","ref":"dsl-ashcloak.html#cloak-on_decrypt","title":"AshCloak.cloak.on_decrypt","type":"DSL"},{"doc":"A list of attributes that should be decrypted (their calculation should be loaded) by default.","ref":"dsl-ashcloak.html#cloak-decrypt_by_default","title":"AshCloak.cloak.decrypt_by_default","type":"DSL"},{"doc":"The attribute or attributes to encrypt. The attribute will be renamed to `encrypted_{attribute}`, and a calculation with the same name will be added.","ref":"dsl-ashcloak.html#cloak-attributes","title":"AshCloak.cloak.attributes","type":"DSL"},{"doc":"The vault to use to encrypt & decrypt the value","ref":"dsl-ashcloak.html#cloak-vault","title":"AshCloak.cloak.vault","type":"DSL"},{"doc":"Encrypt attributes of a resource","ref":"dsl-ashcloak.html#cloak","title":"AshCloak.cloak","type":"DSL"},{"doc":"An extension for encrypting attributes of a resource.\n\nSee the getting started guide for more information.","ref":"AshCloak.html","title":"AshCloak","type":"module"},{"doc":"Introspection functions for the `AshCloak` extension.","ref":"AshCloak.Info.html","title":"AshCloak.Info","type":"module"},{"doc":"The attribute or attributes to encrypt. The attribute will be renamed to `encrypted_{attribute}`, and a calculation with the same name will be added.","ref":"AshCloak.Info.html#cloak_attributes/1","title":"AshCloak.Info.cloak_attributes/1","type":"function"},{"doc":"The attribute or attributes to encrypt. The attribute will be renamed to `encrypted_{attribute}`, and a calculation with the same name will be added.","ref":"AshCloak.Info.html#cloak_attributes!/1","title":"AshCloak.Info.cloak_attributes!/1","type":"function"},{"doc":"A list of attributes that should be decrypted (their calculation should be loaded) by default.","ref":"AshCloak.Info.html#cloak_decrypt_by_default/1","title":"AshCloak.Info.cloak_decrypt_by_default/1","type":"function"},{"doc":"A list of attributes that should be decrypted (their calculation should be loaded) by default.","ref":"AshCloak.Info.html#cloak_decrypt_by_default!/1","title":"AshCloak.Info.cloak_decrypt_by_default!/1","type":"function"},{"doc":"A function to call when decrypting any value. Takes the resource, field, records, and calculation context. Must return `:ok` or `{:error, error}`","ref":"AshCloak.Info.html#cloak_on_decrypt/1","title":"AshCloak.Info.cloak_on_decrypt/1","type":"function"},{"doc":"A function to call when decrypting any value. Takes the resource, field, records, and calculation context. Must return `:ok` or `{:error, error}`","ref":"AshCloak.Info.html#cloak_on_decrypt!/1","title":"AshCloak.Info.cloak_on_decrypt!/1","type":"function"},{"doc":"cloak DSL options\n\nReturns a map containing the and any configured or default values.","ref":"AshCloak.Info.html#cloak_options/1","title":"AshCloak.Info.cloak_options/1","type":"function"},{"doc":"The vault to use to encrypt & decrypt the value","ref":"AshCloak.Info.html#cloak_vault/1","title":"AshCloak.Info.cloak_vault/1","type":"function"},{"doc":"The vault to use to encrypt & decrypt the value","ref":"AshCloak.Info.html#cloak_vault!/1","title":"AshCloak.Info.cloak_vault!/1","type":"function"},{"doc":"# Get Started with AshCloak","ref":"getting-started-with-cloak.html","title":"Get Started with AshCloak","type":"extras"},{"doc":"Add `ash_cloak` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ash_cloak, \"~> 0.1.0-rc.0\"}\n  ]\nend\n```\n\nFollow [the cloak getting started guide](https://hexdocs.pm/cloak/readme.html).\n\nTechnically, you just need a module that implements `encrypt!` and `decrypt!`, but we recommend using `Cloak` to achieve that goal.","ref":"getting-started-with-cloak.html#installation","title":"Installation - Get Started with AshCloak","type":"extras"},{"doc":"```elixir\ndefmodule User do\n  use Ash.Resource, extensions: [AshCloak]\n\n  cloak do\n    # the vault to use to encrypt them\n    vault MyApp.Vault\n    # the attributes to encrypt\n    attributes [:address, :phone_number]\n    # This is just equivalent to always providing `load: fields` on all calls\n    decrypt_by_default [:address]\n    # An MFA or function to be invoked beforce any decryption\n    on_decrypt fn records, field, context ->\n      # Ash has policies that allow forbidding certain users to load data.\n      # You should generally use those for authorization rules, and\n      # only use this callback for auditing/logging.\n      Audit.user_accessed_encrypted_field(records, field, context)\n\n      if context.user.name == \"marty\" do\n        {:error, \"No martys at the party!\"}\n      else\n        :ok\n      end\n    end\n  end\nend\n```","ref":"getting-started-with-cloak.html#add-the-extension-to-your-resource-s","title":"Add the extension to your resource(s): - Get Started with AshCloak","type":"extras"},{"doc":"","ref":"getting-started-with-cloak.html#what-does-the-extension-do","title":"What does the extension do? - Get Started with AshCloak","type":"extras"},{"doc":"First, we change the name of each attribute in question to `encrypted_ `, and make it `public?: false` and `sensitive?: true`.\n\nThen, we add a _calculation_ matching the original attribute that, when loaded, will decrypt the given attribute and calls any configured `on_decrypt` callback.","ref":"getting-started-with-cloak.html#rewrite-attributes-to-calculations","title":"Rewrite attributes to calculations - Get Started with AshCloak","type":"extras"},{"doc":"Then, we go through each create, udpate and destroy action that accepts the attribute, and remove the attribute from the accept list.\n\nThen, we add an argument by the same name, and a change that encrypts the attribute value.\n\nThis change also deletes the argument from the arguments list and from the params. This is a small extra layer of security to prevent accidental leakage of the value.","ref":"getting-started-with-cloak.html#modify-actions","title":"Modify Actions - Get Started with AshCloak","type":"extras"},{"doc":"Finally, we add a preparation and a change that will automatically load the corresponding calculations for any attribute in the `decrypt_by_default` list.","ref":"getting-started-with-cloak.html#add-preparation-change","title":"Add preparation & change - Get Started with AshCloak","type":"extras"},{"doc":"<!--\nThis file was generated by Spark. Do not edit it by hand.\n-->\n# DSL: AshCloak\n\nAn extension for encrypting attributes of a resource.\n\nSee the getting started guide for more information.","ref":"dsl-ashcloak.html","title":"DSL: AshCloak","type":"extras"},{"doc":"Encrypt attributes of a resource","ref":"dsl-ashcloak.html#cloak","title":"cloak - DSL: AshCloak","type":"extras"},{"doc":"| Name | Type | Default | Docs |\n|------|------|---------|------|\n| [`vault`](#cloak-vault){: #cloak-vault .spark-required} | `module` |  | The vault to use to encrypt & decrypt the value |\n| [`attributes`](#cloak-attributes){: #cloak-attributes } | `atom \\| list(atom)` | `[]` | The attribute or attributes to encrypt. The attribute will be renamed to `encrypted_{attribute}`, and a calculation with the same name will be added. |\n| [`decrypt_by_default`](#cloak-decrypt_by_default){: #cloak-decrypt_by_default } | `atom \\| list(atom)` | `[]` | A list of attributes that should be decrypted (their calculation should be loaded) by default. |\n| [`on_decrypt`](#cloak-on_decrypt){: #cloak-on_decrypt } | `(any, any, any, any -> any) \\| mfa` |  | A function to call when decrypting any value. Takes the resource, field, records, and calculation context. Must return `:ok` or `{:error, error}` |\n\n\n\n\n\n\n\n .spark-required::after { content: \"*\"; color: red !important; }","ref":"dsl-ashcloak.html#options","title":"Options - DSL: AshCloak","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,50,46,49]}}